/* addressBook.h was originally generated by the autoSql program, which also 
 * generated addressBook.c and addressBook.sql.  This header links the database and
 * the RAM representation of objects. */

#ifndef ADDRESSBOOK_H
#define ADDRESSBOOK_H

struct addressBook
/* A simple address book */
    {
    struct addressBook *next;  /* Next in singly linked list. */
    char *name;	/* Name - first or last or both, we don't care */
    char *address;	/* Street address */
    char *city;	/* City */
    unsigned zipCode;	/* A zip code is always positive, so can be unsigned */
    char state[3];	/* Just store the abbreviation for the state */
    };

void addressBookStaticLoad(char **row, struct addressBook *ret);
/* Load a row from addressBook table into ret.  The contents of ret will
 * be replaced at the next call to this function. */

struct addressBook *addressBookLoad(char **row);
/* Load a addressBook from row fetched with select * from addressBook
 * from database.  Dispose of this with addressBookFree(). */

struct addressBook *addressBookLoadAll(char *fileName);
/* Load all addressBook from a tab-separated file.
 * Dispose of this with addressBookFreeList(). */

struct addressBook *addressBookCommaIn(char **pS, struct addressBook *ret);
/* Create a addressBook out of a comma separated string. 
 * This will fill in ret if non-null, otherwise will
 * return a new addressBook */

void addressBookFree(struct addressBook **pEl);
/* Free a single dynamically allocated addressBook such as created
 * with addressBookLoad(). */

void addressBookFreeList(struct addressBook **pList);
/* Free a list of dynamically allocated addressBook's */

void addressBookOutput(struct addressBook *el, FILE *f, char sep, char lastSep);
/* Print out addressBook.  Separate fields with sep. Follow last field with lastSep. */

#define addressBookTabOut(el,f) addressBookOutput(el,f,'\t','\n');
/* Print out addressBook as a line in a tab-separated file. */

#define addressBookCommaOut(el,f) addressBookOutput(el,f,',',',');
/* Print out addressBook as a comma separated list including final comma. */

#endif /* ADDRESSBOOK_H */

